#include <AI8G.H>
#include "define.h"
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

#define		RXD			P30
#define		TXD			P31
#define		FOSC		11059200UL
#define		BAUD		9600UL						//
#define		TMRF		200UL						//ʱƵ
#define		BRT			(0x10000-(FOSC/BAUD+2)/4)	//ʷֵ
#define		TMR			(0x10000-FOSC/TMRF/12)		//ʱֵ
#define		R_Buf_Len	64							//Uart1ջ泤
#define		T_Buf_Len	64							//Uart1ͻ泤
#define		R			0							//485
#define		T			1							//485

unsigned char		RP;					//Uart1ָ
unsigned char		TP;					//Uart1ָ
unsigned char		Uart_R_Len;			//Uart1ճ
unsigned char		Uart_T_Len;			//Uart1ͳ
unsigned char xdata	R_Buf[R_Buf_Len];	//Uart1ջ
unsigned char xdata	T_Buf[T_Buf_Len];	//Uart1ͻ

char USER_STCISPCMD[]="@STCISP#";	//ûԶ壬޸ģISPõһ£

///*----------------------------ʱ10us@STC-Y6@11.0592MHz----------------------------*/
//void Delay_10us(void)
//{
//	unsigned char i;
//	i=35;
//	while(--i);
//}

///*----------------------------ʱx10us----------------------------*/
//void Delay_x10us(unsigned char x)
//{
//	while(x--)
//		Delay_10us();
//}

/*----------------------------ʱ10ms@STC-Y6@11.0592MHz----------------------------*/
void Delay_10ms(void)
{
	unsigned char i,j;
	_nop_();
	_nop_();
	i=144;
	j=157;
	do
	{
		while(--j);
	}while(--i);
}

/*----------------------------ʱx10ms----------------------------*/
void Delay_x10ms(unsigned char x)
{
	while(x--)
		Delay_10ms();
}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_T_Len=x;
	TI=1;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(Uart_T_Len);
	UART_Send(vsprintf(T_Buf,v,ap));
	va_end(ap);
}

void UART_Return(unsigned char temp)
{
	memcpy(T_Buf,R_Buf,temp);
	UART_Send(temp);
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0M1=0x00;	P0M0=0x00;	//IOģʽ
	P1M1=0x00;	P1M0=0x00;	//IOģʽ
	P2M1=0x00;	P2M0=0x00;	//IOģʽ
	P3M1=0x00;	P3M0=0x00;	//IOģʽ
	P4M1=0x00;	P4M0=0x00;	//IOģʽ
	P5M1=0x00;	P5M0=0x00;	//IOģʽ
	P6M1=0x00;	P6M0=0x00;	//IOģʽ
	P7M1=0x00;	P7M0=0x00;	//IOģʽ
	
	AUXR=0x40;		//öʱ0ʱΪ12Tģʽöʱ1Ϊ1Tģʽöʱ1Ϊʷ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽöʱ1Ϊ16λԶװģʽ
	TH0=TMR>>8;		//öʱ0ʼֵ
	TL0=TMR;		//öʱ0ʼֵ
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	SCON=0x50;		//UART1ģʽΪ8λݿɱ䲨
	TH1=BRT>>8;		//UART1
	TL1=BRT;		//UART1
	TR1=1;			//򿪶ʱ1
	ES=1;			//UART1ж
	
	EA=1;			//ж
}

void main(void)
{
	Init();
	Uart_Printf("AI8G1K08A auto download test.\r\n");
	while(1)
	{
		Uart_Printf("AI8G1K08A running.\r\n");
		Delay_x10ms(100);
	}
}

void Uart_Start(void)
{
	TL0=0x00;
	TH0=0xEE;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TL0=0x00;
	TH0=0xEE;
	RP=0;
	memset(R_Buf,0x00,sizeof R_Buf);
}

void Timer0_Isr(void) interrupt 1 
{
	UART_Return(RP);	//ʱԭ
	Uart_Stop();
}

void Uart_Isr(void) interrupt 4
{
	if(RI)
	{
		RI=0;
		Uart_Start();
		R_Buf[RP]=SBUF;
		if((RP==sizeof USER_STCISPCMD-2)&&(memcmp(R_Buf,USER_STCISPCMD,sizeof USER_STCISPCMD-1)==0))	//յûλISP
		{
			IAP_CONTR=0x60;
		}
		if(RP==R_Buf_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(TI)
	{
		TI=0;
		if(TP==Uart_T_Len)
		{
//			TR=R;	//485շ
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
//			TR=T;	//485շ
			SBUF=(T_Buf[TP]);
			TP++;
		}
	}
}